


;; This checks the generation and the way we deal with bound variables, mapping functions, etc. 
;; It randomly generates trees and calls a bunch of functions on them 

(load "HSFL-General.scm")

; Some functions for testing out the PCFG 
(define          G (make-PCFG))
(add-PCFG-rules! G 
                 (make-PCFG-RULEgs 'S 'EXPR 1)
                 (make-PCFG-RULEgs 'EXPR '(FN2 EXPR EXPR) 1)
                 (make-PCFG-RULEgs 'EXPR '(FN1 EXPR) 1)
                 (make-PCFG-RULEgs 'EXPR 'NUM 1)
                 
                 (make-PCFG-RULEgs 'NUM '1 1)
                 (make-PCFG-RULEgs 'NUM '2 1)
                 
                 (make-PCFG-RULEgs 'FN2 '+ 1)
                 (make-PCFG-RULEgs 'FN2 '* 1)
                 (make-PCFG-RULEgs 'FN2 '/ 1)
                 
                 (make-PCFG-RULEgs 'FN1 '(*lambda* EXPR EXPR 5)  1)
                 (make-PCFG-RULEgs 'FN1 'sin 1)
                 (make-PCFG-RULEgs 'FN1 'cos 2)
                 )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define (get-gp alpha)
  (map (lambda (nt)
         (cons (if (member nt possible-bv-nonterminals) alpha 0.0)
               (repeat-item alpha (length (hashtable-ref G nt null)))))
       (vector->list (hashtable-keys G))))

(define possible-bv-nonterminals (get-possible-bv-nonterminals G))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define sample (make-PCFG-hashtable))
(define gp (get-gp 0.90))

(repeat 30000
        (lambda ()
          (define t  (PCFG-generate G 'S 10))
        
            
        (hashtable-set! sample t (PCFG-prior-score-count score-p-RR
                                                         (get-PCFG-rule-counts G t) 
                                                         gp))
         #t
          
          ))

(for k in (vector->list (hashtable-keys sample))
  (displayn (hashtable-ref sample k 0)
            "\t"
            (PCFG-prior-score-count score-p-RR-flat
                                    (get-PCFG-rule-counts G k) 
                                    (get-gp 1.0))
            "\t"
            (PCFG-log-probability k)
            "\t"
            "\"" (PCFG-delabel k) "\""
            "\t"
            ))




(exit)

;#[PCFG-NODE S (#[PCFG-NODE NP (dog) -0.6931471805599453 -0.6931471805599453] #[PCFG-NODE VP (hates #[PCFG-NODE NP (dog) -0.6931471805599453 -0.6931471805599453]) -1.3862943611198906 -2.0794415416798357]) -0.6931471805599453 -3.4657359027997265]



