#!/usr/bin/perl

# this looks in condor_files and creates a submit_condor.txt file that will submit to condor
# the lisping of all of those files!

use strict;

my $myroot = "/data/scratch/piantado/SFL-huge/Vicare";


print <<EOT;

Universe 	= vanilla
Executable 	= /data/scratch/piantado/vicare-0.1d5/src/vicare
notification    = Never
environment 	= VICARE_LIBRARY_PATH=/data/scratch/piantado/vicare-0.1d5:/data/scratch/piantado/vicare-0.1d5/lib/:/data/scratch/piantado/Libraries/r6rs-scheme:$myroot:\$VICARE_LIBRARY_PATH;LD_LIBRARY_PATH=/data/scratch/piantado/vicare-0.1d5:/data/scratch/piantado/vicare-0.1d5/lib/:\$LD_LIBRARY_PATH;LOT_LIB_PATH=/data/scratch/piantado/Libraries/LOT-lib/;
requirements = (machine != "cocosci-1.csail.mit.edu") && (machine != "argon3.csail.mit.edu") && (machine != "delaware.csail.mit.edu")

nice_user    = True

EOT

my $mcmc_steps = 150000; # 100000

my $pid = 0;

#for(my $r=0;$r<5;$r++) {
my $r=0;

	

# foreach my $language ( "Language-SimpleBoolean", "Language-OnlyFeatures", "Language-CNF", "Language-DNF", "Language-NAND", "Language-NOR", "Language-FullBoolean", "Language-Implies", "Language-Biconditional", "Language-HornClause", "Language-LAM-QEF-EOQ-CRD-Q2O-SMC", "Language-LAM-QEF-EOQ-CRD-Q2O", "Language-LAM-QEF-EOQ-CRD-SMC", "Language-LAM-QEF-EOQ-CRD", "Language-LAM-QEF-EOQ-Q2O-SMC", "Language-LAM-QEF-EOQ-Q2O", "Language-LAM-QEF-EOQ-SMC", "Language-LAM-QEF-EOQ", "Language-LAM-QEF-CRD-Q2O-SMC", "Language-LAM-QEF-CRD-Q2O", "Language-LAM-QEF-CRD-SMC", "Language-LAM-QEF-CRD", "Language-LAM-QEF-Q2O-SMC", "Language-LAM-QEF-Q2O", "Language-LAM-QEF-SMC", "Language-LAM-QEF", "Language-LAM-EOQ-CRD-Q2O-SMC", "Language-LAM-EOQ-CRD-Q2O", "Language-LAM-EOQ-CRD-SMC", "Language-LAM-EOQ-CRD", "Language-LAM-EOQ-Q2O-SMC", "Language-LAM-EOQ-Q2O", "Language-LAM-EOQ-SMC", "Language-LAM-EOQ", "Language-LAM-CRD-Q2O-SMC", "Language-LAM-CRD-Q2O", "Language-LAM-CRD-SMC", "Language-LAM-CRD", "Language-LAM-Q2O-SMC", "Language-LAM-Q2O", "Language-LAM-SMC", "Language-LAM", ) {	
# foreach my $language ( "Language-SimpleBoolean",  ) {	


foreach my $concept ( "hg01", "hg02", "hg03", "hg04", "hg05", "hg06", "hg07", "hg08", "hg09", "hg10", "hg11", "hg12", "hg13", "hg14", "hg15", "hg16", "hg17", "hg18", "hg19", "hg20", "hg21", "hg22", "hg23", "hg24", "hg25", "hg26", "hg27", "hg28", "hg29", "hg30", "hg31", "hg32", "hg33", "hg34", "hg35", "hg36", "hg37", "hg38", "hg39", "hg40", "hg41", "hg42", "hg43", "hg44", "hg45", "hg46", "hg47", "hg48", "hg49", "hg50", "hg51", "hg52", "hg53", "hg54", "hg55", "hg56", "hg57", "hg58", "hg59", "hg60", "hg61", "hg62", "hg63", "hg64", "hg65", "hg66", "hg67", "hg68", "hg69", "hg70", "hg71", "hg72", "hg73", "hg74", "hg75", "hg76", "hg77", "hg78", "hg79", "hg80", "hg81", "hg82", "hg83", "hg84", "hg85", "hg86", "hg87", "hg88", "hg89", "hg90", "hg91", "hg92", "hg93", "hg94", "hg95", "hg96", "hg97", "hg98", "hg99", "hg100", "hg101", "hg102", "hg103", "hg104", "hg105", "hg106", "hg107", "hg108", "hg109", "hg110", "hg111", "hg112"){


foreach my $list ("L1", "L2",) {

	###################
	#
	#
	#
	#
	#
	#
	#
	#
	#
	#
	#
	#
	# MUST remove this if we run on boolean again!
# 	if($language !~ m/LAM/) { next; } # skip these for now


#  	if($pid == 1 || $pid == 29) {
print <<EOT

		Log		= /data/scratch/piantado/SFL-huge/Vicare/log-mcmc/log_$concept\_L$list.\$(Process).txt
		Error		= /data/scratch/piantado/SFL-huge/Vicare/log-mcmc/err_$concept\_L$list.\$(Process).txt
		Output		= /dev/null
		# We have to load ikarus with the boot file
		Arguments	= -b /data/scratch/piantado/vicare-0.1d5/vicare.boot /data/scratch/piantado/SFL-huge/Vicare/HSFL-MCMC-generate-hypotheses.scm -- DATA-PATH /data/scratch/piantado/SFL-huge/Vicare/concepts/ CONCEPT $concept LIST $list LANGUAGE $language MCMC-STEPS $mcmc_steps OUT-PREFIX /data/scratch/piantado/SFL-huge/Vicare/mcmc-hypotheses/
		Queue
EOT
 	}
 	$pid++;
# }
}
}
#/usr/local/bin/ikarus  /data/scratch/piantado/SFL-small/SFL-Inference.scm DATA-FILE /data/scratch/piantado/SFL-small/concepts/

sub seq {
	my $min = $_[0];
	my $max = $_[1];
	my $step = $_[2];

	my @o;
	for(my $i=$min;$i<=$max;$i += $step) {
		push @o, $i;
	}

	return @o;
}




